#! /bin/sh

# -------------------------------------------------------------------------- #
# Copyright 2002-2025, OpenNebula Project, OpenNebula Systems                #
#                                                                            #
# Licensed under the Apache License, Version 2.0 (the "License"); you may    #
# not use this file except in compliance with the License. You may obtain    #
# a copy of the License at                                                   #
#                                                                            #
# http://www.apache.org/licenses/LICENSE-2.0                                 #
#                                                                            #
# Unless required by applicable law or agreed to in writing, software        #
# distributed under the License is distributed on an "AS IS" BASIS,          #
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #
# See the License for the specific language governing permissions and        #
# limitations under the License.                                             #
#--------------------------------------------------------------------------- #

if [ -z "$ONE_LOCATION" ]; then
    FLOW_PID=/var/run/one/oneflow.pid
    FLOW_SERVER=/usr/lib/one/oneflow/oneflow-server.rb
    FLOW_LOCK_FILE=/var/lock/one/.oneflow.lock
    FLOW_LOG=/var/log/one/oneflow.log
    FLOW_LOG_ERROR=/var/log/one/oneflow.error
    FLOW_CONF=/etc/one/oneflow-server.conf
else
    FLOW_PID=$ONE_LOCATION/var/oneflow.pid
    FLOW_SERVER=$ONE_LOCATION/lib/oneflow/oneflow-server.rb
    FLOW_LOCK_FILE=$ONE_LOCATION/var/.oneflow.lock
    FLOW_LOG=$ONE_LOCATION/var/oneflow.log
    FLOW_LOG_ERROR=$ONE_LOCATION/var/oneflow.error
    FLOW_CONF=$ONE_LOCATION/etc/oneflow-server.conf
fi

setup()
{
  if [ -f $FLOW_LOCK_FILE ]; then
    if [ -f  $FLOW_PID ]; then
      FLOWPID=`cat $FLOW_PID`
      ps $FLOWPID > /dev/null 2>&1
      if [ $? -eq 0 ]; then
        echo "OneFlow Server is still running (PID:$FLOWPID)."
        echo "Please try 'oneflow-server stop' first."
        exit 1
      fi
    fi
    echo "Stale .lock detected. Erasing it."
    rm $FLOW_LOCK_FILE
  fi
}

start()
{
  if [ ! -f "$FLOW_SERVER" ]; then
    echo "Cannot find $FLOW_SERVER."
    exit 1
  fi

  touch $FLOW_LOCK_FILE

  # Start the oneflow-server daemon
  ruby $FLOW_SERVER >>$FLOW_LOG 2>>$FLOW_LOG_ERROR &

  LASTRC=$?
  LASTPID=$!

  if [ $LASTRC -ne 0 ]; then
        echo "Error executing oneflow-server."
        echo "Check $FLOW_LOG_ERROR and $FLOW_LOG for more information"
    exit 1
  else
    echo $LASTPID > $FLOW_PID
  fi

  sleep 2
  ps $LASTPID > /dev/null 2>&1

  if [ $? -ne 0 ]; then
        echo "Error executing oneflow-server."
        echo "Check $FLOW_LOG_ERROR and $FLOW_LOG for more information"
    exit 1
  fi

  echo "oneflow-server started"
}

#
# Function that stops the daemon/service
#
stop()
{
  if [ ! -f $FLOW_PID ]; then
    echo "Couldn't find oneflow-server process pid."
    exit 1
  fi

  # Kill the oneflow-server daemon

  kill -INT `cat $FLOW_PID` > /dev/null 2>&1

  # Remove pid files
  rm -f $FLOW_PID > /dev/null 2>&1
  rm -f $FLOW_LOCK_FILE &> /dev/null

  echo "oneflow-server stopped"
}


case "$1" in
  start)
  setup
  start
  ;;
  stop)
  stop
  ;;
  *)
  echo "Usage: oneflow-server {start|stop}" >&2
  exit 3
  ;;
esac


